/**
 * Author: Josiah Yoder et al.
 * Class: SE2811-011
 * Date: 12/9/13 8:27 AM
 * Lesson: Week 2, Day 2
 */
package start2_3.ducks;

import java.awt.Point;

public abstract class Duck {
    double topLeftX;
    double topLeftY;
    private String name;
    private SwimBehavior swimBehavior;

    protected Duck(String name) {
        this.name = name;
        this.swimBehavior = new Floating();
    }

    protected Duck() {
        this("Anon.");
    }

    private Point getPosition() {
        return new Point((int)topLeftX, (int) topLeftY);
    }

    protected void setSwimBehavior(SwimBehavior swimBehavior) {
        this.swimBehavior = swimBehavior;
    }

    private void setPosition(Point point) {
        topLeftX = point.getX();
        topLeftY = point.getY();
    }

    public void quack() {

    }

    public void swim() {
        setPosition(swimBehavior.swim(getPosition()));
    }

    public void display() {
        System.out.println("The duck "+name+
                " is at ("+topLeftX+", "+topLeftY
                +")");
    }
}
