/**
 * Author: Josiah Yoder et al.
 * Class: SE2811-011
 * Date: 12/9/13 8:27 AM
 * Lesson: Week 2, Day 2
 */
package start2_3.ducks.yoder;

import start2_3.ducks.*;

import java.util.ArrayList;
import java.util.Scanner;

public class DuckDriver {
    public static final int NO_DUCK = Integer.MAX_VALUE;
    public static final int FINISHED = 0;
    public static final int MALLARD = 1;
    public static final int DARKWING_DUCK = 2;

    public static void main(String[] ignored) {
        int duckType = NO_DUCK;
        Duck newDuck = null;
        ArrayList<Duck> ducks = new ArrayList<Duck>();
        Scanner in = new Scanner(System.in);

        while(duckType != FINISHED) {
            System.out.println("Please enter a duck type: ");
            System.out.println(" 0. Exit");
            System.out.println(" 1. Mallard");
            System.out.println(" 2. DarkWing");
            duckType = in.nextInt();

            if(duckType == MALLARD) {
                newDuck = new Mallard();
            }
            else if(duckType == DARKWING_DUCK) {
                System.out.println("Creating DarkWing Duck, the rocket-powered super-hero.");
                System.out.println("Please enter the amount of fuel for DarkWing's jet-pack, in Kg: (decimal part allowed)");
                double rocketFuelKg = in.nextDouble();

                newDuck = new DarkWingDuck(rocketFuelKg);
            }
            else {
                newDuck = null;
            }

            if(newDuck != null) {
                ducks.add(newDuck);
            }
        }

        System.out.println("");
        System.out.println("Ducks entered:");
        for(Duck duck : ducks) {
            System.out.println(duck);
        }

        System.out.println("");
        System.out.println("Swim, ducks, swim:");
        for(Duck duck : ducks) {
            duck.swim();
        }
    }
}
